/* Process model C form file: cdpd_mdbs_col_stat.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char cdpd_mdbs_col_stat_pr_c [] = "MIL_3_Tfile_Hdr_ 90A 30A op_runsim 7 3E306C01 3E306C01 1 payette saviol 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                     ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif

#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		col_count;
	Stathandle	             		col_count_stathandle;
	} cdpd_mdbs_col_stat_state;

#define pr_state_ptr            		((cdpd_mdbs_col_stat_state*) SimI_Mod_State_Ptr)
#define col_count               		pr_state_ptr->col_count
#define col_count_stathandle    		pr_state_ptr->col_count_stathandle

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cdpd_mdbs_col_stat_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_mdbs_col_stat (void);
	Compcode cdpd_mdbs_col_stat_init (void **);
	void cdpd_mdbs_col_stat_diag (void);
	void cdpd_mdbs_col_stat_terminate (void);
	void cdpd_mdbs_col_stat_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_mdbs_col_stat (void)
	{
	int _block_origin = 0;
	FIN (cdpd_mdbs_col_stat ());
	if (1)
		{


		FSM_ENTER (cdpd_mdbs_col_stat)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "cdpd_mdbs_col_stat [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_col_stat [init enter execs]", state0_enter_exec)
				{
				/* Register Local Statistics */
				
				col_count = 0;
				col_count_stathandle = op_stat_reg ("collision count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_col_stat [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "cdpd_mdbs_col_stat [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_col_stat [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_col_stat [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "col_stat")
				/*---------------------------------------------------------*/



			/** state (col_stat) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "col_stat", "cdpd_mdbs_col_stat [col_stat enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_col_stat [col_stat enter execs]", state1_enter_exec)
				{
				/* If I get an interrupt (from statistic stream)
				increase collision counter and write to statistics */
				
				if (op_intrpt_type()==OPC_INTRPT_STAT)
				{
					col_count++;
					op_stat_write(col_count_stathandle, col_count);
				}
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_col_stat [col_stat enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,cdpd_mdbs_col_stat)


			/** state (col_stat) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "col_stat", "cdpd_mdbs_col_stat [col_stat exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_col_stat [col_stat exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_col_stat [col_stat exit execs]", state1_exit_exec)


			/** state (col_stat) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "col_stat", "col_stat")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,cdpd_mdbs_col_stat)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cdpd_mdbs_col_stat_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cdpd_mdbs_col_stat_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cdpd_mdbs_col_stat)",
			sizeof (cdpd_mdbs_col_stat_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cdpd_mdbs_col_stat_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cdpd_mdbs_col_stat_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cdpd_mdbs_col_stat_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cdpd_mdbs_col_stat_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_mdbs_col_stat_svar function. */
#undef col_count
#undef col_count_stathandle



void
cdpd_mdbs_col_stat_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cdpd_mdbs_col_stat_state		*prs_ptr;

	FIN (cdpd_mdbs_col_stat_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_mdbs_col_stat_state *)gen_ptr;

	if (strcmp ("col_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->col_count);
		FOUT
		}
	if (strcmp ("col_count_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->col_count_stathandle);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

