/* Process model C form file: cdpd_mdbs_mac.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char cdpd_mdbs_mac_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3EC9AE7C 3EC9AE7C 1 payette saviol 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                         ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define RVS_INSTRM    0
#define GEN_INSTRM    1
#define SINK_OUTSTRM  0
#define FWD_OUTSTRM   1

//#define	GEN_PKT_ARV (op_intrpt_type()==OPC_INTRPT_STRM && op_intrpt_strm()==GEN_INSTRM)
#define GEN_PKT (op_intrpt_type()==OPC_INTRPT_STAT && (op_intrpt_stat()==2))
#define	RVS_PKT_ARV (op_intrpt_type()==OPC_INTRPT_STRM && op_intrpt_strm()==RVS_INSTRM)

#define GEN_CODE 0
#define	IDLE	1
#define	BUSY	0
#define NIL					0
// Decode Status Flag acoording to specification is:
// Decode Success  00000
// Decode Failure  11111
//#define FAILURE 0
//#define SUCCESS 1
#define FAILURE	1
#define SUCCESS 0

static void send_fwd_packet (Packet *, int);

Objid  mdbs_id;

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Packet *	               		send_frmptr;
	Packet *	               		rvs_frmptr;
	int	                    		bis;
	int	                    		decode;
	Objid	                  		node_id;
	Objid	                  		bis_mon_id;
	int	                    		counter;
	int	                    		gen_counter;
	Objid	                  		decode_set_id;
	Stathandle	             		decode_stathandle;
	Stathandle	             		bis_stathandle;
	Stathandle	             		control_packet_count;
	Sbhandle	               		rsm_buf_ptr;
	Packet *	               		seg_ptr;
	Sbhandle	               		seg_buf_ptr;
	int	                    		frame_label;
	int	                    		blk_size;
	char *	                 		fmt_name;
	} cdpd_mdbs_mac_state;

#define pr_state_ptr            		((cdpd_mdbs_mac_state*) SimI_Mod_State_Ptr)
#define send_frmptr             		pr_state_ptr->send_frmptr
#define rvs_frmptr              		pr_state_ptr->rvs_frmptr
#define bis                     		pr_state_ptr->bis
#define decode                  		pr_state_ptr->decode
#define node_id                 		pr_state_ptr->node_id
#define bis_mon_id              		pr_state_ptr->bis_mon_id
#define counter                 		pr_state_ptr->counter
#define gen_counter             		pr_state_ptr->gen_counter
#define decode_set_id           		pr_state_ptr->decode_set_id
#define decode_stathandle       		pr_state_ptr->decode_stathandle
#define bis_stathandle          		pr_state_ptr->bis_stathandle
#define control_packet_count    		pr_state_ptr->control_packet_count
#define rsm_buf_ptr             		pr_state_ptr->rsm_buf_ptr
#define seg_ptr                 		pr_state_ptr->seg_ptr
#define seg_buf_ptr             		pr_state_ptr->seg_buf_ptr
#define frame_label             		pr_state_ptr->frame_label
#define blk_size                		pr_state_ptr->blk_size
#define fmt_name                		pr_state_ptr->fmt_name

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cdpd_mdbs_mac_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
void send_fwd_packet(Packet *pk, int strm)
{
	Packet *tmp_pk;
	int i=0;
	
	for (i=0;i<2;i++)
	{
	tmp_pk= op_pk_copy(pk);
	op_pk_send(tmp_pk, strm);
	}
}

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_mdbs_mac (void);
	Compcode cdpd_mdbs_mac_init (void **);
	void cdpd_mdbs_mac_diag (void);
	void cdpd_mdbs_mac_terminate (void);
	void cdpd_mdbs_mac_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_mdbs_mac (void)
	{
	int _block_origin = 0;
	FIN (cdpd_mdbs_mac ());
	if (1)
		{
		extern FILE *fp;
		Packet 		*gen_frmptr;
		//double		bis_flg;
		//double		decode_flg;
		int 	comp_frm_cnt;
		Packet	*frm_ptr;
		Packet	*blk_ptr;


		FSM_ENTER (cdpd_mdbs_mac)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "cdpd_mdbs_mac [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [init enter execs]", state0_enter_exec)
				{
				/* Here we do all initialization necessary.  Appropriate 	*/
				/* PDF's are loaded, statistics are initialized, object 	*/
				/* id's are gotten, etc. 									*/
				/* the busy-idle status bit is "busy". 						*/
				//counter     = 0;
				bis         = IDLE;
				decode      = SUCCESS;
				gen_counter	= 0;
				//RVS_PKT_ARVD=0;
				
				//node_id = op_topo_parent (op_id_self ());
				//mdbs_id=node_id;
				//bis_mon_id = op_id_from_name (node_id, OPC_OBJTYPE_PROC, "bis_set");
				//decode_set_id = op_id_from_name (node_id, OPC_OBJTYPE_PROC, "decode_set");
				
				bis_stathandle       = op_stat_reg ("Busy/Idle Status Flag", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				decode_stathandle    = op_stat_reg ("Decode Status Flag", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				control_packet_count = op_stat_reg ("control packets count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				rsm_buf_ptr = op_sar_buf_create(OPC_SAR_BUF_TYPE_REASSEMBLY, OPC_SAR_BUF_OPT_FLUSH_AUTO);
				seg_buf_ptr = op_sar_buf_create(OPC_SAR_BUF_TYPE_SEGMENT, OPC_SAR_BUF_OPT_DEFAULT);
				
				send_frmptr = op_pk_create_fmt("cdpd_forward_packet2");
				op_pk_nfd_set (send_frmptr, "bis", bis);
				
				/* Get the decode status of the lastest received */
				/* packet from the reverse channel and set the   */
				/* decode flag in the forward channel packet 	 */
				/* accordingly									 */
				
				op_pk_nfd_set (send_frmptr, "decode", decode);
				op_pk_send(send_frmptr, FWD_OUTSTRM);
				gen_counter++;
				op_stat_write(control_packet_count, gen_counter);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "cdpd_mdbs_mac [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "cdpd_mdbs_mac [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [idle enter execs]", state1_enter_exec)
				{
				/* MDBS keep monitoring the busy/idle status */
				/* and decode status on the reverse channel  */
				//op_ima_obj_attr_get (bis_mon_id, "bis", &bis);
				//op_ima_obj_attr_get (decode_set_id,  "decode", &decode_flg);
				
				
				if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat()==0))
				{
					if (op_stat_local_read(0)==0)
						bis = IDLE;
					else
						bis = BUSY;
				}
				
				if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat()==1))
				{
					if (op_stat_local_read(1)==0)
						decode = SUCCESS;
					else
						decode = FAILURE;
				}
				if((op_intrpt_type()==OPC_INTRPT_STRM)&& (op_intrpt_strm()==GEN_INSTRM))
				{
					gen_frmptr = op_pk_get(GEN_INSTRM);
					op_sar_segbuf_pk_insert(seg_buf_ptr, gen_frmptr, frame_label++);
					gen_frmptr = op_pk_create_fmt("cdpd_frm_flag_seq");
					op_sar_segbuf_pk_insert(seg_buf_ptr, gen_frmptr, frame_label++);	
				}
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,cdpd_mdbs_mac)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "cdpd_mdbs_mac [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [idle exit execs]", state1_exit_exec)
				{
				/* Grab the bis and the decode values on idle exit */
				/* This means that we don't have to re-read it later (might have changed later */
				
				/*bis_flg = op_stat_local_read (0);
				
				if (bis_flg == 0.0)
					bis = IDLE;
				else
					bis = BUSY;
				
				decode_flg = op_stat_local_read (1);
				
				if (decode_flg == 0.0)
					decode = SUCCESS;
				else
					decode = FAILURE;
				*/
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (GEN_PKT)
			FSM_TEST_COND (RVS_PKT_ARV)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 3, state3_enter_exec, ;, "GEN_PKT", "", "idle", "bis_set")
				FSM_CASE_TRANSIT (1, 4, state4_enter_exec, ;, "RVS_PKT_ARV", "", "idle", "decode_flg_set")
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (xmit) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "xmit", "cdpd_mdbs_mac [xmit enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [xmit enter execs]", state2_enter_exec)
				{
				/* Send out the control packet through the forward channel */
				
				/*if(gen_pkptr!=OPC_NIL)
				{
					cp_pkptr=op_pk_copy(gen_pkptr);
					send_fwd_packet (cp_pkptr, FWD_OUTSTRM);
				}*/
				
				op_pk_send(send_frmptr, FWD_OUTSTRM);
				
				gen_counter++;
				op_stat_write(control_packet_count, gen_counter);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [xmit enter execs]", state2_enter_exec)

			/** state (xmit) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "xmit", "cdpd_mdbs_mac [xmit exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [xmit exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [xmit exit execs]", state2_exit_exec)


			/** state (xmit) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "xmit", "idle")
				/*---------------------------------------------------------*/



			/** state (bis_set) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "bis_set", "cdpd_mdbs_mac [bis_set enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [bis_set enter execs]", state3_enter_exec)
				{
				/* set the  busy/idle flag  forward channel packet*/
				blk_size = 274;
				blk_ptr = op_sar_srcbuf_seg_remove(seg_buf_ptr, blk_size);
				send_frmptr = op_pk_create_fmt("cdpd_forward_packet2");
				op_pk_nfd_set(send_frmptr, "MDLP Data", blk_ptr);
				op_pk_nfd_set (send_frmptr, "bis", bis);
				
				/* Get the decode status of the lastest received */
				/* packet from the reverse channel and set the   */
				/* decode flag in the forward channel packet 	 */
				/* accordingly									 */
				
				op_pk_nfd_set (send_frmptr, "decode", decode);
				
				op_stat_write (decode_stathandle, decode);
				op_stat_write (bis_stathandle, bis);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [bis_set enter execs]", state3_enter_exec)

			/** state (bis_set) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "bis_set", "cdpd_mdbs_mac [bis_set exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [bis_set exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [bis_set exit execs]", state3_exit_exec)


			/** state (bis_set) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "bis_set", "xmit")
				/*---------------------------------------------------------*/



			/** state (decode_flg_set) enter executives **/
			FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "decode_flg_set", "cdpd_mdbs_mac [decode_flg_set enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [decode_flg_set enter execs]", state4_enter_exec)
				{
				rvs_frmptr = op_pk_get (RVS_INSTRM);
				if (rvs_frmptr != NIL)
				{
				/* The following is two sets of if statments.
				Only use ONE.  It's used to remove the 50 bit preamble flag
				Both method works although the second method is better code
				since it checks for the exact format name type.
				However, due to unexplained (and uncorrectable) bus errors 
				with the use of strcmp (string compare) the first method MUST 
				be used if multiple M-ES is present until this problem is 
				resolved */
				    if (op_pk_total_size_get(rvs_frmptr) < 274)
						op_pk_destroy(rvs_frmptr);
				/*	op_pk_format_info_get(rvs_frmptr, OPC_PK_PROPERTY_FORMAT_NAME, &fmt_name);
					printf("fmt_name is %s\n", &fmt_name);
					if (strcmp (&fmt_name, "cdpd_reverse_packet1") == 0) // get rid of preamble packet//	if (op_pk_total_size_get(rvs_pkptr) < 274)
					{
						op_pk_destroy(rvs_frmptr);
						printf("destroyed cdpd_reverse_packet1\n");
					}*/
					else
					{
						op_pk_nfd_get(rvs_frmptr, "MDLP Data", &seg_ptr);
						if (op_sar_pk_is_segment(seg_ptr))
						{
							op_sar_rsmbuf_seg_insert(rsm_buf_ptr, seg_ptr);
						}
						op_pk_destroy(rvs_frmptr);
						comp_frm_cnt = op_sar_rsmbuf_pk_count(rsm_buf_ptr);
						while (comp_frm_cnt > 0)
						{
							frm_ptr = op_sar_rsmbuf_pk_remove(rsm_buf_ptr);
							
				/* The following is two sets of if statments.
				Only use ONE.  It's used to distinguish between the delimiting
				flags and the frame content.  The first one works if the frame 
				types are not formated.  Else you end up with all data 
				destroyed. The alternate method (second if) is preferred.  
				However, due to unexplained (and uncorrectable) bus errors 
				with the use of strcmp (string compare) the first method MUST 
				be used if multiple M-ES is present until this problem is 
				resolved */
				
						    if (op_pk_type(frm_ptr) == OPC_PACKET_TYPE_FORMATTED)
								op_pk_destroy(frm_ptr);
							
				/*			if (op_pk_type(frm_ptr)== OPC_PACKET_TYPE_FORMATTED)
							{
								// Only needed to check for now if it's formatted type but 
							    // this is futureproof
								op_pk_format_info_get(frm_ptr, OPC_PK_PROPERTY_FORMAT_NAME, &fmt_name);
								printf("format type is %s\n", &fmt_name);
								if (strcmp(&fmt_name, "cdpd_frm_flag_seq") == 0) // get rid of frame flag sequence
								{
									printf("destroyed cdpd_frm_flag_seq\n");			
									op_pk_destroy(frm_ptr);
								}
							}*/
							else
								op_pk_send(frm_ptr, SINK_OUTSTRM);
							comp_frm_cnt--;
						}
					}
				}
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [decode_flg_set enter execs]", state4_enter_exec)

			/** state (decode_flg_set) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "decode_flg_set", "cdpd_mdbs_mac [decode_flg_set exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mdbs_mac [decode_flg_set exit execs]", state4_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mdbs_mac [decode_flg_set exit execs]", state4_exit_exec)


			/** state (decode_flg_set) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "decode_flg_set", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,cdpd_mdbs_mac)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cdpd_mdbs_mac_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cdpd_mdbs_mac_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cdpd_mdbs_mac)",
			sizeof (cdpd_mdbs_mac_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cdpd_mdbs_mac_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cdpd_mdbs_mac_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cdpd_mdbs_mac_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cdpd_mdbs_mac_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_mdbs_mac_svar function. */
#undef send_frmptr
#undef rvs_frmptr
#undef bis
#undef decode
#undef node_id
#undef bis_mon_id
#undef counter
#undef gen_counter
#undef decode_set_id
#undef decode_stathandle
#undef bis_stathandle
#undef control_packet_count
#undef rsm_buf_ptr
#undef seg_ptr
#undef seg_buf_ptr
#undef frame_label
#undef blk_size
#undef fmt_name



void
cdpd_mdbs_mac_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cdpd_mdbs_mac_state		*prs_ptr;

	FIN (cdpd_mdbs_mac_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_mdbs_mac_state *)gen_ptr;

	if (strcmp ("send_frmptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->send_frmptr);
		FOUT
		}
	if (strcmp ("rvs_frmptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rvs_frmptr);
		FOUT
		}
	if (strcmp ("bis" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->bis);
		FOUT
		}
	if (strcmp ("decode" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decode);
		FOUT
		}
	if (strcmp ("node_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->node_id);
		FOUT
		}
	if (strcmp ("bis_mon_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->bis_mon_id);
		FOUT
		}
	if (strcmp ("counter" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->counter);
		FOUT
		}
	if (strcmp ("gen_counter" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->gen_counter);
		FOUT
		}
	if (strcmp ("decode_set_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decode_set_id);
		FOUT
		}
	if (strcmp ("decode_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decode_stathandle);
		FOUT
		}
	if (strcmp ("bis_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->bis_stathandle);
		FOUT
		}
	if (strcmp ("control_packet_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->control_packet_count);
		FOUT
		}
	if (strcmp ("rsm_buf_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsm_buf_ptr);
		FOUT
		}
	if (strcmp ("seg_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->seg_ptr);
		FOUT
		}
	if (strcmp ("seg_buf_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->seg_buf_ptr);
		FOUT
		}
	if (strcmp ("frame_label" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->frame_label);
		FOUT
		}
	if (strcmp ("blk_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->blk_size);
		FOUT
		}
	if (strcmp ("fmt_name" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->fmt_name);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

