/* Process model C form file: cdpd_mes_channel_monitor.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char cdpd_mes_channel_monitor_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3EC9AF15 3EC9AF15 1 payette saviol 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                         ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define PKT_ARRVL (op_intrpt_type () == OPC_INTRPT_STRM	)
#define IDLE	1
#define BUSY	0
#define SINK_OUTSTRM 0
#define NIL		0

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		busy_idle;
	int	                    		decode;
	Stathandle	             		bis_stathandle;
	Stathandle	             		decode_stathandle;
	Stathandle	             		control_packets_count;
	int	                    		ctrl_pk_counter;
	Sbhandle	               		rsm_buf_ptr;
	Packet *	               		seg_ptr;
	Packet *	               		frm_ptr;
	char *	                 		fmt_name;
	} cdpd_mes_channel_monitor_state;

#define pr_state_ptr            		((cdpd_mes_channel_monitor_state*) SimI_Mod_State_Ptr)
#define busy_idle               		pr_state_ptr->busy_idle
#define decode                  		pr_state_ptr->decode
#define bis_stathandle          		pr_state_ptr->bis_stathandle
#define decode_stathandle       		pr_state_ptr->decode_stathandle
#define control_packets_count   		pr_state_ptr->control_packets_count
#define ctrl_pk_counter         		pr_state_ptr->ctrl_pk_counter
#define rsm_buf_ptr             		pr_state_ptr->rsm_buf_ptr
#define seg_ptr                 		pr_state_ptr->seg_ptr
#define frm_ptr                 		pr_state_ptr->frm_ptr
#define fmt_name                		pr_state_ptr->fmt_name

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cdpd_mes_channel_monitor_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_mes_channel_monitor (void);
	Compcode cdpd_mes_channel_monitor_init (void **);
	void cdpd_mes_channel_monitor_diag (void);
	void cdpd_mes_channel_monitor_terminate (void);
	void cdpd_mes_channel_monitor_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_mes_channel_monitor (void)
	{
	int _block_origin = 0;
	FIN (cdpd_mes_channel_monitor ());
	if (1)
		{
		
		Packet*		frmptr;
		double		status;
		extern FILE *fp;
		int			comp_frm_cnt;


		FSM_ENTER (cdpd_mes_channel_monitor)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "cdpd_mes_channel_monitor [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [init enter execs]", state0_enter_exec)
				{
				bis_stathandle        = op_stat_reg ("Busy/Idle Status Flag", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				decode_stathandle     = op_stat_reg ("Decode Status Flag", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				control_packets_count = op_stat_reg ("control packets count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				ctrl_pk_counter = 0;
				rsm_buf_ptr = op_sar_buf_create(OPC_SAR_BUF_TYPE_REASSEMBLY, OPC_SAR_BUF_OPT_FLUSH_AUTO);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "cdpd_mes_channel_monitor [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [init exit execs]", state0_exit_exec)
				{
				busy_idle=1;
				decode=1;
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "cdpd_mes_channel_monitor [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [idle enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,cdpd_mes_channel_monitor)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "cdpd_mes_channel_monitor [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [idle exit execs]", state1_exit_exec)
				{
				/* In the AMPS specification, IDLE is defined as a value of 1	*/
				/* and busy is defined as 0.  Here we simply monitor the busy	*/
				/* stat of the access channel receiver and set the bit as it	*/
				/* changes.  The mobiles will access this object attribute to	*/
				/* check the value.												*/
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PKT_ARRVL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PKT_ARRVL", "", "idle", "bis_set")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (bis_set) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "bis_set", "cdpd_mes_channel_monitor [bis_set enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [bis_set enter execs]", state2_enter_exec)
				{
				frmptr = op_pk_get (op_intrpt_strm ());
				
				ctrl_pk_counter++;
				op_stat_write (control_packets_count, ctrl_pk_counter);
				
				if (frmptr != NIL)
				{
					op_pk_nfd_get(frmptr, "MDLP Data", &seg_ptr);
				
					/* Extract busy/idle state. */
					op_pk_nfd_get (frmptr, "bis", &busy_idle);
					op_stat_write(bis_stathandle, busy_idle);
				
					/* Extract decode success state. */
					op_pk_nfd_get (frmptr, "decode", &decode);
					op_stat_write(decode_stathandle, decode);
					
					if (seg_ptr != NIL)
					{
						if (op_sar_pk_is_segment(seg_ptr))
						{
							op_sar_rsmbuf_seg_insert(rsm_buf_ptr, seg_ptr);
						}
						op_pk_destroy(frmptr);
						comp_frm_cnt = op_sar_rsmbuf_pk_count(rsm_buf_ptr);
						while (comp_frm_cnt > 0)
						{
							frm_ptr = op_sar_rsmbuf_pk_remove(rsm_buf_ptr);
				
				/* The following is two sets of if statments.
				Only use ONE.  It's used to distinguish between the delimiting
				flags and the frame content.  The first one works if the frame 
				types are not formated.  Else you end up with all data 
				destroyed. The alternate method (second if) is preferred.  
				However, due to unexplained (and uncorrectable) bus errors 
				with the use of strcmp (string compare) the first method MUST 
				be used if multiple M-ES is present until this problem is 
				resolved */
				
							if (op_pk_type(frm_ptr) == OPC_PACKET_TYPE_FORMATTED)
								op_pk_destroy(frm_ptr);
				
							
				/*			if (op_pk_type(frm_ptr)== OPC_PACKET_TYPE_FORMATTED)
							{
								op_pk_format_info_get(frm_ptr, OPC_PK_PROPERTY_FORMAT_NAME, &fmt_name);
				//				printf("ch mon fmt type is %s\n", &fmt_name);
								if (strcmp (&fmt_name, "cdpd_frm_flag_seq") == 0)// get rid of frame flag sequence
								{
				//					printf("ch mon destroyed cdpd_frm_flag_seq\n");
									op_pk_destroy(frm_ptr);
								}
						    }*/
							else
								op_pk_send(frm_ptr, SINK_OUTSTRM);
							comp_frm_cnt--;
						}
					}
				}
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [bis_set enter execs]", state2_enter_exec)

			/** state (bis_set) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "bis_set", "cdpd_mes_channel_monitor [bis_set exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [bis_set exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_mes_channel_monitor [bis_set exit execs]", state2_exit_exec)


			/** state (bis_set) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "bis_set", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,cdpd_mes_channel_monitor)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cdpd_mes_channel_monitor_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cdpd_mes_channel_monitor_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cdpd_mes_channel_monitor)",
			sizeof (cdpd_mes_channel_monitor_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cdpd_mes_channel_monitor_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cdpd_mes_channel_monitor_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cdpd_mes_channel_monitor_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cdpd_mes_channel_monitor_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_mes_channel_monitor_svar function. */
#undef busy_idle
#undef decode
#undef bis_stathandle
#undef decode_stathandle
#undef control_packets_count
#undef ctrl_pk_counter
#undef rsm_buf_ptr
#undef seg_ptr
#undef frm_ptr
#undef fmt_name



void
cdpd_mes_channel_monitor_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cdpd_mes_channel_monitor_state		*prs_ptr;

	FIN (cdpd_mes_channel_monitor_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_mes_channel_monitor_state *)gen_ptr;

	if (strcmp ("busy_idle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->busy_idle);
		FOUT
		}
	if (strcmp ("decode" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decode);
		FOUT
		}
	if (strcmp ("bis_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->bis_stathandle);
		FOUT
		}
	if (strcmp ("decode_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->decode_stathandle);
		FOUT
		}
	if (strcmp ("control_packets_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->control_packets_count);
		FOUT
		}
	if (strcmp ("ctrl_pk_counter" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->ctrl_pk_counter);
		FOUT
		}
	if (strcmp ("rsm_buf_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rsm_buf_ptr);
		FOUT
		}
	if (strcmp ("seg_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->seg_ptr);
		FOUT
		}
	if (strcmp ("frm_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->frm_ptr);
		FOUT
		}
	if (strcmp ("fmt_name" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->fmt_name);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

