/* Process model C form file: cdpd_sink.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char cdpd_sink_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3EC9A8FE 3EC9A8FE 1 payette saviol 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                         ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */


#define ARRIVAL         op_intrpt_type () == OPC_INTRPT_STRM

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		counter;
	Stathandle	             		Stathandle_frame_count;
	int	                    		byte_size;
	Stathandle	             		byte_size_stathandle;
	} cdpd_sink_state;

#define pr_state_ptr            		((cdpd_sink_state*) SimI_Mod_State_Ptr)
#define counter                 		pr_state_ptr->counter
#define Stathandle_frame_count  		pr_state_ptr->Stathandle_frame_count
#define byte_size               		pr_state_ptr->byte_size
#define byte_size_stathandle    		pr_state_ptr->byte_size_stathandle

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cdpd_sink_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_sink (void);
	Compcode cdpd_sink_init (void **);
	void cdpd_sink_diag (void);
	void cdpd_sink_terminate (void);
	void cdpd_sink_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_sink (void)
	{
	int _block_origin = 0;
	FIN (cdpd_sink ());
	if (1)
		{
		Packet* frmptr;


		FSM_ENTER (cdpd_sink)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (DISCARD) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "DISCARD", "cdpd_sink [DISCARD enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [DISCARD enter execs]", state0_enter_exec)
				{
				counter++;
				op_stat_write(Stathandle_frame_count, counter);
				frmptr = op_pk_get(op_intrpt_strm());
				byte_size=op_pk_total_size_get(frmptr);
				op_stat_write(byte_size_stathandle, byte_size);
				op_pk_destroy (frmptr);
				
				//printf("Counter is equal to : %d", counter);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_sink [DISCARD enter execs]", state0_enter_exec)

			/** state (DISCARD) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "DISCARD", "cdpd_sink [DISCARD exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [DISCARD exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_sink [DISCARD exit execs]", state0_exit_exec)


			/** state (DISCARD) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "DISCARD", "idle")
				/*---------------------------------------------------------*/



			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (1, "init", "cdpd_sink [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [init enter execs]", state1_enter_exec)
				{
				counter=0;
				Stathandle_frame_count=op_stat_reg ("frame count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				byte_size_stathandle = op_stat_reg ("byte size", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_sink [init enter execs]", state1_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "init", "cdpd_sink [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [init exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_sink [init exit execs]", state1_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (2, state2_enter_exec, "idle", "cdpd_sink [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [idle enter execs]", state2_enter_exec)
				{
				//printf("I am just waiting! \n");
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_sink [idle enter execs]", state2_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (5,cdpd_sink)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (2, "idle", "cdpd_sink [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [idle exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_sink [idle exit execs]", state2_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_sink [idle trans conditions]", state2_trans_conds)
			FSM_INIT_COND (ARRIVAL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("cdpd_sink [idle trans conditions]", state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;, "ARRIVAL", "", "idle", "DISCARD")
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (1,cdpd_sink)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cdpd_sink_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cdpd_sink_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cdpd_sink)",
			sizeof (cdpd_sink_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cdpd_sink_state *)(*gen_state_pptr))->current_block = 2;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cdpd_sink_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cdpd_sink_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cdpd_sink_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_sink_svar function. */
#undef counter
#undef Stathandle_frame_count
#undef byte_size
#undef byte_size_stathandle



void
cdpd_sink_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cdpd_sink_state		*prs_ptr;

	FIN (cdpd_sink_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_sink_state *)gen_ptr;

	if (strcmp ("counter" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->counter);
		FOUT
		}
	if (strcmp ("Stathandle_frame_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->Stathandle_frame_count);
		FOUT
		}
	if (strcmp ("byte_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->byte_size);
		FOUT
		}
	if (strcmp ("byte_size_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->byte_size_stathandle);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

