/* Process model C form file: trc_drvn_src.pr.c */
/* Portions of this file copyright 1992-2001 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char trc_drvn_src_pr_c [] = "MIL_3_Tfile_Hdr_ 80C 30A op_runsim 7 3D779E75 3D779E75 1 hermes saviol 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                      ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "string.h"
#include "stdlib.h"
#include "stdio.h"
#include "math.h"
/*Packet stream definitions */
#define SRC_OUT_STRM	0
#define SEND			(op_intrpt_type()== OPC_INTRPT_SELF)
/*extern FILE	*fp;*/

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	List*	                  		line_list_ptr;
	List*	                  		field_list_ptr;
	int	                    		line_index;
	int	                    		list_size;
	int	                    		line_counter;
	} trc_drvn_src_state;

#define pr_state_ptr            		((trc_drvn_src_state*) SimI_Mod_State_Ptr)
#define line_list_ptr           		pr_state_ptr->line_list_ptr
#define field_list_ptr          		pr_state_ptr->field_list_ptr
#define line_index              		pr_state_ptr->line_index
#define list_size               		pr_state_ptr->list_size
#define line_counter            		pr_state_ptr->line_counter

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	trc_drvn_src_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void trc_drvn_src (void);
	Compcode trc_drvn_src_init (void **);
	void trc_drvn_src_diag (void);
	void trc_drvn_src_terminate (void);
	void trc_drvn_src_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
trc_drvn_src (void)
	{
	int _block_origin = 0;
	FIN (trc_drvn_src ());
	if (1)
		{
		char	*file_name;
		int 	i;
		double	send_time;
		char	err_str[256];
		Packet	*pk_ptr;
		
		int		pk_size;
		
		


		FSM_ENTER (trc_drvn_src)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (Init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "Init", "trc_drvn_src () [Init enter execs]")
				{
				line_counter=1;
				
				/*- "script" file  should be obtained from the 'trace'-*/
				file_name="sierra"; 
				
				/*-Start from the first line-*/		
				line_index=0;			
				pk_size=2000;
				send_time=0;
				
				/*------Read The Script File into a list of strings---*/
				line_list_ptr=op_prg_gdf_read (file_name);
				
				if (line_list_ptr == OPC_NIL)	/*-Failed in reading the file-*/
					{
					sprintf(err_str, "File Name: %s", file_name);
					op_sim_end ("err: cannot load file",err_str,"","");
					}
				list_size = op_prg_list_size (line_list_ptr);
				
				
				/*-------Decomposite the first line of the file into a list of fields---*/
				field_list_ptr=op_prg_str_decomp(op_prg_list_access(line_list_ptr, line_index), " ,/\t");
				line_index++;
				
				/*-------Get the time at which the first packet should be generated----*/
				send_time=(double)atof(op_prg_list_access(field_list_ptr, 0));
				if(send_time< op_sim_time())
					send_time=op_sim_time();
				
				/*-------Schedule a self interrupt --------*/
				op_intrpt_schedule_self(send_time,0);
				}


			/** state (Init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "Init", "trc_drvn_src () [Init exit execs]")
				{
				}


			/** state (Init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "Init", "Idle")
				/*---------------------------------------------------------*/



			/** state (Idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "Idle", "trc_drvn_src () [Idle enter execs]")
				{
				
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,trc_drvn_src)


			/** state (Idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "Idle", "trc_drvn_src () [Idle exit execs]")
				{
				if (op_intrpt_type ()== OPC_INTRPT_SELF && line_counter< list_size)
				{
				
				/*-Get the size of the packet to be generated-*/
				pk_size=atoi(op_prg_list_access(field_list_ptr,1));
				pk_size=pk_size*8;
				
				
				/*--Create a packet with the pakcet size 'pk_size'-*/
				pk_ptr=op_pk_create(pk_size);
				
				
				/*--Send the packet through the out going stream---*/
					op_pk_send(pk_ptr, SRC_OUT_STRM);
				
				/*-------Decomposite the next line of the file into a list of fields---*/
				op_prg_list_free(field_list_ptr);
				field_list_ptr=op_prg_str_decomp(op_prg_list_access(line_list_ptr,line_index), " ,/\t");
				line_index++;
				
				
				/*-------Get the time at which the next packet should be generated----*/
				send_time=(double)atof(op_prg_list_access(field_list_ptr,0));
				
				
				if(send_time<op_sim_time())
					send_time=op_sim_time();
				
				
				/*-------Schedule a self interrupt --------*/
				op_intrpt_schedule_self(send_time,0);
				line_counter++;
				}
				}


			/** state (Idle) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "Idle", "Idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,trc_drvn_src)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
trc_drvn_src_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (trc_drvn_src_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (trc_drvn_src)",
			sizeof (trc_drvn_src_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((trc_drvn_src_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
trc_drvn_src_diag (void)
	{
	/* No Diagnostic Block */
	}




void
trc_drvn_src_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (trc_drvn_src_terminate (void))

	if (1)
		{
		char	*file_name;
		int 	i;
		double	send_time;
		char	err_str[256];
		Packet	*pk_ptr;
		
		int		pk_size;
		
		

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in trc_drvn_src_svar function. */
#undef line_list_ptr
#undef field_list_ptr
#undef line_index
#undef list_size
#undef line_counter



void
trc_drvn_src_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	trc_drvn_src_state		*prs_ptr;

	FIN (trc_drvn_src_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (trc_drvn_src_state *)gen_ptr;

	if (strcmp ("line_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->line_list_ptr);
		FOUT;
		}
	if (strcmp ("field_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->field_list_ptr);
		FOUT;
		}
	if (strcmp ("line_index" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->line_index);
		FOUT;
		}
	if (strcmp ("list_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->list_size);
		FOUT;
		}
	if (strcmp ("line_counter" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->line_counter);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}

